#include "common.h"

bool busy = false;
int owner = -1;
struct lock lock;
struct condition cond;

void pinit(void) {
	lock_init(&lock);
	cond_init(&cond);
}

void plock(int tid) {
	lock_acquire(&lock);
	while (busy)
		cond_wait(&cond, &lock);
	busy = true;
	owner = tid;
	lock_release(&lock);
}

void punlock(int tid) {
	UNUSED(tid);
	lock_acquire(&lock);
	owner = -1;
	busy = false;
	cond_signal(&cond, &lock);
	lock_release(&lock);
}

